[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.36 and 1.95

version 1.36, 2021/11/27 06:38:06 version 1.95, 2021/12/21 02:16:47
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 #       $OpenBSD$  #       $OpenBSD$
 set -e  #
   # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 # Fake up some things from install.sub that we don't need to actually do  set -o errexit -o pipefail -o nounset -o noclobber -o noglob
 prefetcharea_fs_list() {  set +o monitor
         echo "${DESTDIR}/tmp"  export PATH=/usr/bin:/bin:/usr/sbin:/sbin
 }  
   
 # tmpdir, do_as, unpriv, and unpriv2 are from install.sub  CFILE=SHA256.sig
   DESTDIR=${DESTDIR:-}
   FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
   
 # Create a temporary directory based on the supplied directory name prefix.  VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
   VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
   HTTP_FWDIR="$VNAME"
   VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
       /var/run/dmesg.boot | sed '$!d' )
   [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
   
   FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
   FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   DOWNLOAD=true
   INSTALL=true
   LOCALSRC=
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
         until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do          # If we're not in the installer,
                 ((++_i < 10000)) || return 1          # we have mktemp and a more hostile environment.
         done          if [ -x /usr/bin/mktemp ]; then
                   _dir=$( mktemp -d "${1}-XXXXXXXXX" )
           else
                   until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
                       ((++_i < 10000)) || return 1
                   done
           fi
   
         echo "$_dir"          echo "$_dir"
 }  }
   
 # Run a command ($2+) as unprivileged user ($1).  fetch() {
 # Take extra care that after "cmd" no "user" processes exist.          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''
 #  
 # Optionally:  
 #       - create "file" and chown it to "user"  
 #       - after "cmd", chown "file" back to root  
 #  
 # Usage: do_as user [-f file] cmd  
 do_as() {  
         (( $# >= 2 )) || return  
   
         local _file _rc _user=$1          # If we're not in the installer,
         shift          # we have su(1) and doas(1) is unlikely to be configured.
           set -o monitor # make sure ftp gets its own process group
           (
           if [ -x /usr/bin/su ]; then
                   exec /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
           else
                   exec /usr/bin/doas -u "$_user" \
                       /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
           fi
           ) & _pid=$!
           set +o monitor
   
         if [[ $1 == -f ]]; then          trap "kill -TERM '-$_pid'; exit 1" EXIT INT QUIT ABRT TERM
                 _file=$2  
                 shift 2          SECONDS=0
           _last=0
           while kill -0 -"$_pid" 2>/dev/null; do
                   if [[ $SECONDS -gt 12 ]]; then
                           set -- $( ls -ln "$_dst" 2>/dev/null )
                           if [[ $_last -ne $5 ]]; then
                                   _last=$5
                                   SECONDS=0
                                   sleep 1
                           else
                                   kill -INT -"$_pid"
                                   _error=" (timed out)"
                           fi
                   else
                           sleep 1
                   fi
           done
   
           set +o errexit
           wait "$_pid"
           _exit=$?
           set -o errexit
   
           trap "" EXIT INT QUIT ABRT TERM
   
           if [ "$_exit" -ne 0 ]; then
                   rm -f "$_dst"
                   echo "Cannot fetch $_src$_error" >&2
                   return 1
         fi          fi
   }
   
         if [[ -n $_file ]]; then  verify() {
                 >$_file          # On the installer we don't get sha256 -C, so fake it.
                 chown "$_user" "$_file"          if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                   echo "Checksum test for ${1##*/} failed." >&2
                   return 1
         fi          fi
   }
   
         doas -u "$_user" "$@"  devices_needing_firmware() {
         _rc=$?          local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
         while doas -u "$_user" kill -9 -1 2>/dev/null; do          # When we're not in the installer, the dmesg.boot can
                 echo "Processes still running for user $_user after: $@"          # contain multiple boots, so only look in the last one
                 sleep 1          _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
         done              grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"
   
         [[ -n $_file ]] && chown root "$_file"          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
               while read -r _d _m; do
                   [ "$_d" = "$_last" ] && continue
                   [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                   [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
   
         return $_rc                  if [[ $_dmesgtail = *$_m* ]]; then
                           echo "$_d"
                           _last="$_d"
                   fi
               done
 }  }
   
 unpriv() {  firmware_filename() {
         do_as _sndio "$@"          local _f
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
 }  }
   
 unpriv2() {  firmware_devicename() {
         do_as _file "$@"          local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
 }  }
   
 VNAME=${VNAME:-$(sysctl -n kern.osrelease)}  installed_firmware() {
 VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}          set +o noglob
 FWDIR=${FWDIR:-$VNAME}          for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
 MODE=${MODE:-install}                  [ -e "$fw" ] || continue
                   echo "${fw##*/}"
           done
           set -o noglob
   }
   
 # TODO: We need the firmware for the system we just installed  add_firmware () {
 #       not the one we booted from.  For example:          local _f="${1##*/}"
 #       * booting from a snapshot bsd.rd that thinks it is the 7.0 release          local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
 #         will install the firmware from the 7.0 directory instead of          ftp -D "Install" -Vmo- "file:${1}" |
 #         from the snapshots dir.                  tar -s ",^\+,${_pkgdir}/+," \
 #       If they're using sysupgrade, then the installer kernel will be correct.                      -s ",^firmware,${DESTDIR}/etc/firmware," \
 #       If we're doing this in the installer we can check what they picked                      -C / -zxphf - "+*" "firmware/*"
 #       for downloading sets and use that value.  
 #       Otherwise, the fw_update after first boot will fix it up for us.  
   
 HTTP_FWDIR=$FWDIR          # TODO: Should we mark these so real fw_update can -Drepair?
 set -- sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" /var/run/dmesg.boot          ed -s "${_pkgdir}/+CONTENTS" <<EOL
 [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots  /^@comment pkgpath/ -1a
   @option manual-installation
   @option firmware
   @comment install-script
   .
   w
   EOL
   }
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  delete_firmware() {
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
 FWPATTERNS="file:${0%/*}/firmware_patterns"  
   
 # TODO: support srclocal installation of firmware somehow          # TODO: Check hash for files before deleting
 fw_install() {          echo "Uninstalling $_pkg"
         local _src=$1 _tmpfs_list _tmpfs _tmpsrc \          _cwd="${_pkgdir}/$_pkg"
                 _t=Get _cfile="/tmp/SHA256" _pkgdir=${DESTDIR}/var/db/pkg \  
                 _f _r _remove _i _installed  
         local _srclocal=false _unpriv=unpriv  
   
         echo "Let's $MODE firmware!"          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
         local _d _drivers=$(  
                 last=''  
                 $_unpriv ftp -D "Detecting" -Vmo- $FWPATTERNS |  
                 while read _d _m; do  
                         grep=grep  
                         [ "$last" = "$_d" ] && continue  
                         [ "$_m" ] || _m="^$_d[0-9][0-9]* at "  
                         [ "$_m" = "${_m#^}" ] && grep=fgrep  
                         $grep -q "$_m" /var/run/dmesg.boot || continue  
                         echo $_d  
                         last=$_d  
                 done  
         )  
   
         if [ -z "$_drivers" ]; then          while read -r c g; do
                 echo "No devices found which need firmware files to be downloaded."                  case $c in
                 return                  @cwd) _cwd="${DESTDIR}$g"
         fi                    ;;
                   @*) continue
                     ;;
                   *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                     ;;
                   esac
           done < "${_pkgdir}/${_pkg}/+CONTENTS"
   
         ! _tmpfs_list=$(prefetcharea_fs_list) &&          # We specifically rm -f here because not removing files/dirs
                 echo "Cannot determine prefetch area" >&2 && return          # is probably not worth failing over.
           for _r in "${_remove[@]}" ; do
         for _tmpfs in $_tmpfs_list; do                  if [ -d "$_r" ]; then
                 # Try to clean up from previous runs, assuming                          # Try hard not to actually remove recursively
                 # the _tmpfs selection yields the same mount                          # without rmdir on the install media.
                 # point.                          set +o noglob
                 for _tmpsrc in $_tmpfs/firmware.+([0-9]).+([0-9]); do                          [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                         [[ -d $_tmpsrc ]] && rm -r $_tmpsrc                          set -o noglob
                 done                  else
                           rm -f "$_r"
                 # Create a download directory for the firmware and  
                 # check that the _sndio user can read files from  
                 # it. Otherwise cleanup and skip the filesystem.  
                 if _tmpsrc=$(tmpdir "$_tmpfs/firmware"); then  
                         (  
                         >$_tmpsrc/t &&  
                         $_unpriv cat $_tmpsrc/t  
                         ) >/dev/null 2>&1 && break ||  
                                 rm -r $_tmpsrc  
                 fi                  fi
         done          done
   }
   
         [[ ! -d $_tmpsrc ]] &&  usage() {
                 echo "Cannot create prefetch area" >&2 && return 1          echo "usage:  ${0##*/} [-D | -L] [driver | file ...]"
           exit 2
   }
   
         # Cleanup from previous runs.  OPT_D=
         rm -f $_cfile $_cfile.sig  OPT_L=
   while getopts DL name
   do
          case "$name" in
          D) OPT_D=true ;;
          L) OPT_L=true ;;
          ?) usage 2 ;;
          esac
   done
   shift $((OPTIND - 1))
   
         _t=Get/Verify  [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1
   
         ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&  if [ "$OPT_D" ]; then
             echo "Cannot fetch SHA256.sig" >&2 && return 1          # "Download only" means local dir and don't install
           INSTALL=false
           LOCALSRC=.
   elif [ "$OPT_L" ]; then
           # "Local" means don't download, install from local dir
           DOWNLOAD=false
           LOCALSRC=.
   else
           LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
   fi
   
         # Verify signature file with public keys.  CFILE="$LOCALSRC/$CFILE"
         ! $_unpriv -f "$_cfile" \  
             signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&  
             echo "Signature check of SHA256.sig failed" >&2 && return 1  
   
         for _d in $_drivers; do  if "$INSTALL" && [ -x /usr/bin/id ] && [ $(/usr/bin/id -u) != 0 ]; then
                 _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )          echo "need root privileges" >&2
                 _installed=$(          exit 1
                 for fw in "${_pkgdir}/$_d-firmware"*; do  fi
                         [ -e "$fw" ] || continue  
                         echo ${fw##*/}  
                 done  
                 )  
   
                 for _i in $_installed; do  set -A devices -- "$@"
                         if [ "$_f" = "$_i.tgz" ]; then  
                                 echo "$_i already installed"  
                                 continue 2  
                         fi  
                 done  
   
                 rm -f /tmp/h /tmp/fail  if [ ! "${devices[*]:-}" ]; then
           echo -n "Detecting firmware ..."
           set -A devices -- $( devices_needing_firmware )
           [ "${devices[*]:-}" ] && echo " found." || echo " done."
   fi
   
                 # Fetch firmware file and create a checksum by piping through  [ "${devices[*]:-}" ] || exit
                 # sha256. Create a flag file in case ftp failed. Firmware  
                 # from net is written to the prefetch area.  
                 ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |  
                 ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||  
                     unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )  
   
                 # Handle failed transfer.  if "$DOWNLOAD"; then
                 if [[ -f /tmp/fail ]]; then          fetch "$CFILE"
                         rm -f "$_tmpsrc/$_f"          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
                         echo "Fetching of $_f failed!" >&2              echo "Signature check of SHA256.sig failed" >&2 && exit 1
                         continue  fi
                 fi  
   
                 # Verify firmware by comparing its checksum with SHA256.  for f in "${devices[@]}"; do
                 if ! fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then          d="$( firmware_devicename "$f" )"
                         [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"  
                         echo "Checksum test for $_f failed." >&2  
                         continue  
                 fi  
   
                 # TODO: Check hash for files before deleting          if [ "$f" = "$d" ]; then
                 if [ "$_installed" ] && [ -e "${_pkgdir}/$_installed/+CONTENTS" ]; then                  f=$( firmware_filename "$d" || true )
                         echo "Uninstalling $_installed"                  [ "$f" ] || continue
                         cwd=${_pkgdir}/$_installed                  f="$LOCALSRC/$f"
           elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
                   echo "Cannot download local file $f" >&2
                   exit 2
           fi
   
                         set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"          set -A installed -- $( installed_firmware "$d" )
   
                         while read c g; do          if "$INSTALL" && [ "${installed[*]:-}" ]; then
                                 case $c in                  for i in "${installed[@]}"; do
                                 @cwd) cwd="${DESTDIR}/$g"                          if [ "${f##*/}" = "$i.tgz" ]; then
                                   ;;                                  echo "$i already installed"
                                 @*) continue                                  continue 2
                                   ;;                          fi
                                 *)  set -A _remove -- "$cwd/$c" "${_remove[@]}"                  done
                                   ;;          fi
                                 esac  
                         done < "${_pkgdir}/$_installed/+CONTENTS"  
   
                         # We specifically rm -f here because not removing files/dirs          if [ -e "$f" ]; then
                         # is probably not worth failing over.                  if "$DOWNLOAD"; then
                         for _r in "${_remove[@]}" ; do                          echo "Verify existing ${f##*/}"
                                 if [ -d "$_r" ]; then                          verify "$f" || continue
                                         # Try hard not to actually remove recursively                  # else assume it was verified when downloaded
                                         # without rmdir on the install media.  
                                         [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"  
                                 else  
                                         rm -f "$_r"  
                                 fi  
                         done  
                 fi                  fi
           elif "$DOWNLOAD"; then
                   fetch  "$f" || continue
                   verify "$f" || continue
           elif "$INSTALL"; then
                   echo "Cannot install ${f##*/}, not found" >&2
                   continue
           fi
   
                 # TODO: Should we mark these so real fw_update can -Drepair?          "$INSTALL" || continue
                 ftp -D "Install" -Vmo- "file:$_tmpsrc/$_f" |  
                         tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \  
                         -s ",^firmware,${DESTDIR}/etc/firmware," \  
                         -C / -zxphf - "+*" "firmware/*"  
   
                 ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL          if [ "${installed[*]:-}" ]; then
 /^@comment pkgpath/ -1a                  for i in "${installed[@]}"; do
 @option manual-installation                          delete_firmware "$i"
 @option firmware                  done
 @comment install-script          fi
 .  
 w  
 EOL  
         done  
 }  
   
 fw_install "$FWURL"          add_firmware "$f"
   done
   

Legend:
Removed from v.1.36  
changed lines
  Added in v.1.95

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>